common: capture metadump output if xfs filesystem check fails
[xfstests-dev.git] / common / xfs
index d971b4a8406980ba0bf27d594e993dd9cf7228aa..b30d289ff6db47131bf9fd306ebd8bb1215d3ed3 100644 (file)
@@ -77,6 +77,69 @@ _scratch_mkfs_xfs_supported()
        return $mkfs_status
 }
 
+# Returns the minimum XFS log size, in units of log blocks.
+_scratch_find_xfs_min_logblocks()
+{
+       local mkfs_cmd="`_scratch_mkfs_xfs_opts`"
+
+       # The smallest log size we can specify is 2M (XFS_MIN_LOG_BYTES) so
+       # pass that in and see if mkfs succeeds or tells us what is the
+       # minimum log size.
+       local XFS_MIN_LOG_BYTES=2097152
+
+       # Try formatting the filesystem with all the options given and the
+       # minimum log size.  We hope either that this succeeds or that mkfs
+       # tells us the required minimum log size for the feature set.
+       #
+       # We cannot use _scratch_do_mkfs because it will retry /any/ failed
+       # mkfs with MKFS_OPTIONS removed even if the only "failure" was that
+       # the log was too small.
+       local extra_mkfs_options="$* -N -l size=$XFS_MIN_LOG_BYTES"
+       eval "$mkfs_cmd $MKFS_OPTIONS $extra_mkfs_options $SCRATCH_DEV" \
+               2>$tmp.mkfserr 1>$tmp.mkfsstd
+       local mkfs_status=$?
+
+       # If the format fails for a reason other than the log being too small,
+       # try again without MKFS_OPTIONS because that's what _scratch_do_mkfs
+       # will do if we pass in the log size option.
+       if [ $mkfs_status -ne 0 ] &&
+          ! egrep -q '(log size.*too small, minimum|external log device.*too small, must be)' $tmp.mkfserr; then
+               eval "$mkfs_cmd $extra_mkfs_options $SCRATCH_DEV" \
+                       2>$tmp.mkfserr 1>$tmp.mkfsstd
+               mkfs_status=$?
+       fi
+
+       # mkfs suceeded, so we must pick out the log block size to do the
+       # unit conversion
+       if [ $mkfs_status -eq 0 ]; then
+               blksz="$(grep '^log.*bsize' $tmp.mkfsstd | \
+                       sed -e 's/log.*bsize=\([0-9]*\).*$/\1/g')"
+               echo $((XFS_MIN_LOG_BYTES / blksz))
+               rm -f $tmp.mkfsstd $tmp.mkfserr
+               return
+       fi
+
+       # Usually mkfs will tell us the minimum log size...
+       if grep -q 'minimum size is' $tmp.mkfserr; then
+               grep 'minimum size is' $tmp.mkfserr | \
+                       sed -e 's/^.*minimum size is \([0-9]*\) blocks/\1/g'
+               rm -f $tmp.mkfsstd $tmp.mkfserr
+               return
+       fi
+       if grep -q 'external log device.*too small, must be' $tmp.mkfserr; then
+               grep 'external log device.*too small, must be' $tmp.mkfserr | \
+                       sed -e 's/^.*must be at least \([0-9]*\) blocks/\1/g'
+               rm -f $tmp.mkfsstd $tmp.mkfserr
+               return
+       fi
+
+       # Don't know what to do, so fail
+       echo "Cannot determine minimum log size" >&2
+       cat $tmp.mkfsstd >> $seqres.full
+       cat $tmp.mkfserr >> $seqres.full
+       rm -f $tmp.mkfsstd $tmp.mkfserr
+}
+
 _scratch_mkfs_xfs()
 {
        local mkfs_cmd="`_scratch_mkfs_xfs_opts`"
@@ -89,6 +152,7 @@ _scratch_mkfs_xfs()
        _scratch_do_mkfs "$mkfs_cmd" "$mkfs_filter" $* 2>$tmp.mkfserr 1>$tmp.mkfsstd
        mkfs_status=$?
 
+       grep -q crc=0 $tmp.mkfsstd && _force_xfsv4_mount_options
 
        if [ $mkfs_status -eq 0 -a "$LARGE_SCRATCH_DEV" = yes ]; then
                # manually parse the mkfs output to get the fs size in bytes
@@ -110,6 +174,26 @@ _scratch_mkfs_xfs()
        return $mkfs_status
 }
 
+# Get the size of an allocation unit of a file.  Normally this is just the
+# block size of the file, but for realtime files, this is the realtime extent
+# size.
+_xfs_get_file_block_size()
+{
+       local path="$1"
+
+       if ! ($XFS_IO_PROG -c "stat -v" "$path" 2>&1 | egrep -q '(rt-inherit|realtime)'); then
+               _get_block_size "$path"
+               return
+       fi
+
+       # Otherwise, call xfs_info until we find a mount point or the root.
+       path="$(readlink -m "$path")"
+       while ! $XFS_INFO_PROG "$path" &>/dev/null && [ "$path" != "/" ]; do
+               path="$(dirname "$path")"
+       done
+       $XFS_INFO_PROG "$path" | grep realtime | sed -e 's/^.*extsz=\([0-9]*\).*$/\1/g'
+}
+
 # xfs_check script is planned to be deprecated. But, we want to
 # be able to invoke "xfs_check" behavior in xfstests in order to
 # maintain the current verification levels.
@@ -160,6 +244,27 @@ _scratch_xfs_db()
        $XFS_DB_PROG "$@" $(_scratch_xfs_db_options)
 }
 
+_test_xfs_db_options()
+{
+       TEST_OPTIONS=""
+       [ "$USE_EXTERNAL" = yes -a ! -z "$TEST_LOGDEV" ] && \
+               TEST_OPTIONS="-l$TEST_LOGDEV"
+       echo $TEST_OPTIONS $* $TEST_DEV
+}
+
+_test_xfs_db()
+{
+       $XFS_DB_PROG "$@" $(_test_xfs_db_options)
+}
+
+_scratch_xfs_admin()
+{
+       local options=("$SCRATCH_DEV")
+       [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
+               options+=("$SCRATCH_LOGDEV")
+       $XFS_ADMIN_PROG "$@" "${options[@]}"
+}
+
 _scratch_xfs_logprint()
 {
        SCRATCH_OPTIONS=""
@@ -294,6 +399,7 @@ _require_xfs_db_command()
        fi
        command=$1
 
+       _scratch_mkfs_xfs >/dev/null 2>&1
        _scratch_xfs_db -x -c "help" | grep $command > /dev/null || \
                _notrun "xfs_db $command support is missing"
 }
@@ -326,6 +432,27 @@ _supports_xfs_scrub()
        return 0
 }
 
+# Save a snapshot of a corrupt xfs filesystem for later debugging.
+_xfs_metadump() {
+       local metadump="$1"
+       local device="$2"
+       local logdev="$3"
+       local compressopt="$4"
+       shift; shift; shift; shift
+       local options="$@"
+       test -z "$options" && options="-a -o"
+
+       if [ "$logdev" != "none" ]; then
+               options="$options -l $logdev"
+       fi
+
+       $XFS_METADUMP_PROG $options "$device" "$metadump"
+       res=$?
+       [ "$compressopt" = "compress" ] && [ -n "$DUMP_COMPRESSOR" ] &&
+               $DUMP_COMPRESSOR "$metadump" &> /dev/null
+       return $res
+}
+
 # run xfs_check and friends on a FS.
 _check_xfs_filesystem()
 {
@@ -342,14 +469,16 @@ _check_xfs_filesystem()
                extra_options="-f"
        fi
 
-       if [ "$2" != "none" ]; then
-               extra_log_options="-l$2"
-               extra_mount_options="-ologdev=$2"
+       local logdev="$2"
+       if [ "$logdev" != "none" ]; then
+               extra_log_options="-l$logdev"
+               extra_mount_options="-ologdev=$logdev"
        fi
 
-       if [ "$3" != "none" ]; then
-               extra_rt_options="-r$3"
-               extra_mount_options=$extra_mount_options" -ortdev=$3"
+       local rtdev="$3"
+       if [ "$rtdev" != "none" ]; then
+               extra_rt_options="-r$rtdev"
+               extra_mount_options=$extra_mount_options" -ortdev=$rtdev"
        fi
        extra_mount_options=$extra_mount_options" $MOUNT_OPTIONS"
 
@@ -379,7 +508,7 @@ _check_xfs_filesystem()
 
        $XFS_LOGPRINT_PROG -t $extra_log_options $device 2>&1 \
                | tee $tmp.logprint | grep -q "<CLEAN>"
-       if [ $? -ne 0 -a "$HOSTOS" = "Linux" ]; then
+       if [ $? -ne 0 ]; then
                _log_err "_check_xfs_filesystem: filesystem on $device has dirty log"
                echo "*** xfs_logprint -t output ***"   >>$seqres.full
                cat $tmp.logprint                       >>$seqres.full
@@ -414,8 +543,15 @@ _check_xfs_filesystem()
        fi
        rm -f $tmp.fs_check $tmp.logprint $tmp.repair
 
+       if [ "$ok" -ne 1 ] && [ "$DUMP_CORRUPT_FS" = "1" ]; then
+               local flatdev="$(basename "$device")"
+               _xfs_metadump "$seqres.$flatdev.check.md" "$device" "$logdev" \
+                       compress >> $seqres.full
+       fi
+
        # Optionally test the index rebuilding behavior.
        if [ -n "$TEST_XFS_REPAIR_REBUILD" ]; then
+               rebuild_ok=1
                $XFS_REPAIR_PROG $extra_options $extra_log_options $extra_rt_options $device >$tmp.repair 2>&1
                if [ $? -ne 0 ]; then
                        _log_err "_check_xfs_filesystem: filesystem on $device is inconsistent (rebuild)"
@@ -424,6 +560,7 @@ _check_xfs_filesystem()
                        echo "*** end xfs_repair output"        >>$seqres.full
 
                        ok=0
+                       rebuild_ok=0
                fi
                rm -f $tmp.repair
 
@@ -435,8 +572,15 @@ _check_xfs_filesystem()
                        echo "*** end xfs_repair output"        >>$seqres.full
 
                        ok=0
+                       rebuild_ok=0
                fi
                rm -f $tmp.repair
+
+               if [ "$rebuild_ok" -ne 1 ] && [ "$DUMP_CORRUPT_FS" = "1" ]; then
+                       local flatdev="$(basename "$device")"
+                       _xfs_metadump "$seqres.$flatdev.rebuild.md" "$device" \
+                               "$logdev" compress >> $seqres.full
+               fi
        fi
 
        if [ $ok -eq 0 ]; then
@@ -614,6 +758,16 @@ _require_xfs_mkfs_ciname()
                || _notrun "need case-insensitive naming support in mkfs.xfs"
 }
 
+# this test requires mkfs.xfs have configuration file support
+_require_xfs_mkfs_cfgfile()
+{
+       echo > /tmp/a
+       _scratch_mkfs_xfs_supported -c options=/tmp/a >/dev/null 2>&1
+       res=$?
+       rm -rf /tmp/a
+       test $res -eq 0 || _notrun "need configuration file support in mkfs.xfs"
+}
+
 # XFS_DEBUG requirements
 _require_xfs_debug()
 {
@@ -735,7 +889,12 @@ _require_xfs_spaceman_command()
        _require_command "$XFS_SPACEMAN_PROG" "xfs_spaceman"
 
        testfile=$TEST_DIR/$$.xfs_spaceman
+       touch $testfile
        case $command in
+       "health")
+               testio=`$XFS_SPACEMAN_PROG -c "health $param" $TEST_DIR 2>&1`
+               param_checked=1
+               ;;
        *)
                testio=`$XFS_SPACEMAN_PROG -c "help $command" $TEST_DIR 2>&1`
        esac
@@ -749,6 +908,8 @@ _require_xfs_spaceman_command()
                _notrun "xfs_spaceman $command failed (old kernel/wrong fs/bad args?)"
        echo $testio | grep -q "foreign file active" && \
                _notrun "xfs_spaceman $command not supported on $FSTYP"
+       echo $testio | grep -q "Inappropriate ioctl for device" && \
+               _notrun "xfs_spaceman $command support is missing (missing ioctl?)"
        echo $testio | grep -q "Function not implemented" && \
                _notrun "xfs_spaceman $command support is missing (missing syscall?)"
 
@@ -789,3 +950,79 @@ _scratch_get_bmx_prefix() {
        _scratch_xfs_db -c "inode ${ino}" -c 'p' >> $seqres.full
        return 1
 }
+
+#
+# Ensures that we don't pass any mount options incompatible with XFS v4
+#
+_force_xfsv4_mount_options()
+{
+       local gquota=0
+       local pquota=0
+
+       # Can't have group and project quotas in XFS v4
+       echo "$MOUNT_OPTIONS" | egrep -q "(gquota|grpquota|grpjquota=|gqnoenforce)" && gquota=1
+       echo "$MOUNT_OPTIONS" | egrep -q "(\bpquota|prjquota|pqnoenforce)" && pquota=1
+
+       if [ $gquota -gt 0 ] && [ $pquota -gt 0 ]; then
+               export MOUNT_OPTIONS=$(echo $MOUNT_OPTIONS \
+                       | sed   -e 's/gquota/QUOTA/g'      \
+                               -e 's/grpquota/QUOTA/g'    \
+                               -e 's/grpjquota=[^, ]/QUOTA/g' \
+                               -e 's/gqnoenforce/QUOTA/g' \
+                               -e "s/QUOTA/defaults/g")
+       fi
+       echo "MOUNT_OPTIONS = $MOUNT_OPTIONS" >>$seqres.full
+}
+
+# Find AG count of mounted filesystem
+_xfs_mount_agcount()
+{
+       $XFS_INFO_PROG "$1" | grep agcount= | sed -e 's/^.*agcount=\([0-9]*\),.*$/\1/g'
+}
+
+# Wipe the superblock of each XFS AGs
+_try_wipe_scratch_xfs()
+{
+       local num='^[0-9]+$'
+       local agcount
+       local agsize
+       local dbsize
+
+       # Try to wipe each SB if there's an existed XFS
+       agcount=`_scratch_xfs_get_sb_field agcount 2>/dev/null`
+       agsize=`_scratch_xfs_get_sb_field agblocks 2>/dev/null`
+       dbsize=`_scratch_xfs_get_sb_field blocksize 2>/dev/null`
+       if [[ $agcount =~ $num && $agsize =~ $num && $dbsize =~ $num ]];then
+               for ((i = 0; i < agcount; i++)); do
+                       $XFS_IO_PROG -c "pwrite $((i * dbsize * agsize)) $dbsize" \
+                               $SCRATCH_DEV >/dev/null;
+               done
+       fi
+
+       # Try to wipe each SB by default mkfs.xfs geometry
+       local tmp=`mktemp -u`
+       unset agcount agsize dbsize
+       _scratch_mkfs_xfs -N 2>/dev/null | perl -ne '
+               if (/^meta-data=.*\s+agcount=(\d+), agsize=(\d+) blks/) {
+                       print STDOUT "agcount=$1\nagsize=$2\n";
+               }
+               if (/^data\s+=\s+bsize=(\d+)\s/) {
+                       print STDOUT "dbsize=$1\n";
+               }' > $tmp.mkfs
+
+       . $tmp.mkfs
+       if [[ $agcount =~ $num && $agsize =~ $num && $dbsize =~ $num ]];then
+               for ((i = 0; i < agcount; i++)); do
+                       $XFS_IO_PROG -c "pwrite $((i * dbsize * agsize)) $dbsize" \
+                               $SCRATCH_DEV >/dev/null;
+               done
+       fi
+       rm -f $tmp.mkfs
+}
+
+_require_xfs_copy()
+{
+       [ -n "$XFS_COPY_PROG" ] || _notrun "xfs_copy binary not yet installed"
+       [ "$USE_EXTERNAL" = yes ] && \
+               _notrun "Cannot xfs_copy with external devices"
+}